diff -ur snort-2.0.2/src/output-plugins/spo_log_tcpdump.h snort-2.0.2-ipv6/src/output-plugins/spo_log_tcpdump.h
--- snort-2.0.2/src/output-plugins/spo_log_tcpdump.h	Mon Apr  1 05:42:19 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_log_tcpdump.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_log_tcpdump.h,v 1.7 2002/03/31 20:42:19 andrewbaker Exp $ */
+/* $Id: spo_log_tcpdump.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* This file gets included in plugbase.h when it is integrated into the rest 
  * of the program.  Sometime in The Future, I'll whip up a bad ass Perl script
diff -ur snort-2.0.2/src/output-plugins/spo_unified.c snort-2.0.2-ipv6/src/output-plugins/spo_unified.c
--- snort-2.0.2/src/output-plugins/spo_unified.c	Tue May 20 03:08:06 2003
+++ snort-2.0.2-ipv6/src/output-plugins/spo_unified.c	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_unified.c,v 1.39 2003/05/19 18:08:06 chrisgreen Exp $ */
+/* $Id: spo_unified.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 /* spo_unified 
  * 
diff -ur snort-2.0.2/src/output-plugins/spo_unified.h snort-2.0.2-ipv6/src/output-plugins/spo_unified.h
--- snort-2.0.2/src/output-plugins/spo_unified.h	Mon Apr  1 05:42:19 2002
+++ snort-2.0.2-ipv6/src/output-plugins/spo_unified.h	Tue Sep 30 13:25:26 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: spo_unified.h,v 1.8 2002/03/31 20:42:19 andrewbaker Exp $ */
+/* $Id: spo_unified.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $ */
 
 #ifndef __SPO_UNIFIED_H__
 #define __SPO_UNIFIED_H__
diff -ur snort-2.0.2/src/parser/IpAddrSet.c snort-2.0.2-ipv6/src/parser/IpAddrSet.c
--- snort-2.0.2/src/parser/IpAddrSet.c	Fri Mar 14 17:28:53 2003
+++ snort-2.0.2-ipv6/src/parser/IpAddrSet.c	Sat Nov 29 16:37:57 2003
@@ -1,4 +1,25 @@
-/* $Id: IpAddrSet.c,v 1.5 2003/03/14 08:28:53 chris_reid Exp $ */
+/* $Id: IpAddrSet.c,v 1.4 2003/11/29 07:37:57 abekatsu Exp $ */
+/*
+ * Copyright(C) 2003 Cyber Solutions Inc.
+ *
+ * Author(s):  Katsuhisa ABE <abekatsu@cysols.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
 /*
  * Copyright(C) 2002 Sourcefire, Inc.
  * 
@@ -38,6 +59,7 @@
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
+#include <netdb.h>
 #endif
 
 #ifdef HAVE_STRINGS_H
@@ -66,18 +88,40 @@
 
 void IpAddrSetPrint(IpAddrSet *ipAddrSet)
 {
+#ifndef HAVE_SOCKADDR_STORAGE
     struct in_addr in;
+#else 
+    char *host = NULL;
+#endif
     size_t offset = 0;
+
     while(ipAddrSet)
     {
         offset = 0;
         if(ipAddrSet->addr_flags & EXCEPT_IP)
             offset += snprintf(buffer, 1024 - offset, "NOT ");
+
+#if HAVE_SOCKADDR_STORAGE
+	host = GetIpAddr(&ipAddrSet->ip_addr);
+	if (host != NULL) {
+	    offset += snprintf(buffer + offset, 1024 - offset, "%s/", host);
+	}
+#else
         in.s_addr = ipAddrSet->ip_addr;
         offset += snprintf(buffer + offset, 1024 - offset, "%s/", 
-                inet_ntoa(in));
+			   inet_ntoa(in));
+#endif
+
+#if HAVE_SOCKADDR_STORAGE
+	host = GetIpAddr(&ipAddrSet->netmask);
+	if (host != NULL) {
+	    offset += snprintf(buffer + offset, 1024 - offset, "%s/", host);
+	}
+#else
         in.s_addr = ipAddrSet->netmask;
         offset += snprintf(buffer + offset, 1024 - offset, "%s", inet_ntoa(in));
+#endif
+
         buffer[offset] = '\0';
         LogMessage("%s\n", buffer);
         ipAddrSet = ipAddrSet->next;
@@ -97,9 +141,14 @@
             /* ENOMEM */
             goto failed;
         }
-        
+
+#if HAVE_SOCKADDR_STORAGE
+        memmove(&(current->ip_addr), &(ipAddrSet->ip_addr), sizeof(struct sockaddr_storage));
+        memmove(&(current->netmask), &(ipAddrSet->netmask), sizeof(struct sockaddr_storage));
+#else
         current->ip_addr = ipAddrSet->ip_addr;
         current->netmask = ipAddrSet->netmask;
+#endif
         current->addr_flags = ipAddrSet->addr_flags;
         current->next = NULL;
 
@@ -121,6 +170,324 @@
 }
 
 
+#if HAVE_SOCKADDR_STORAGE
+/*
+ * Function: GetIpAddr(struct sockaddr_storage *)
+ *
+ * Purpose: wrapper of inet_ntop
+ *
+ * Returns: (char *) strings of IP address or NULL
+ *
+ */
+
+char * GetIpAddr(struct sockaddr_storage *ss) 
+{
+    char host[INET6_ADDRSTRLEN];
+
+    switch(ss->ss_family) {
+    case PF_INET:
+	inet_ntop(PF_INET, (void *)&((struct sockaddr_in *)ss)->sin_addr, 
+		  host, INET_ADDRSTRLEN);
+	break;
+    case PF_INET6:
+	inet_ntop(PF_INET6, (void *)&((struct sockaddr_in6 *)ss)->sin6_addr, 
+		  host, INET6_ADDRSTRLEN);
+	break;
+    default:
+	return NULL;
+    }
+
+    return strdup(host);
+}
+
+/*
+ *
+ * Function: IpAddrTakeAnd(struct sockaddr_storage *dst, 
+ *                     struct sockaddr_storage *ss1, struct sockaddr_storage *ss2)
+ *
+ * Purpose: take AND operation on ss1 and sr2, and output the result to dst.
+ *          Ss1, ss2, and dst are ususally casted to 
+ *          sockaddr_in or sockaddr_in6.   
+ *     
+ *
+ * Returns: 0 if the input data src and dst have the same PF family
+ *          else return -1
+ *
+ */
+
+int
+IpAddrTakeAnd(struct sockaddr_storage *dst, 
+	  struct sockaddr_storage *ss1, struct sockaddr_storage *ss2)
+{
+     int i;
+
+     if (ss1->ss_family != ss2->ss_family) 
+     {
+	  dst = NULL;
+	  // FatalError("ERROR %s(%d): PF Family of netmask is different from ip_addr's one\n", file_name, file_line);
+	  return -1;
+     }
+
+#if HAVE_SOCKADDR_STORAGE_SS_LEN
+     dst->ss_len = ss1->ss_len;
+#endif
+#if HAVE_SOCKADDR_STORAGE_SS_FAMILY
+     dst->ss_family = ss1->ss_family;
+#endif
+     
+     switch (ss1->ss_family)
+     {
+     case PF_INET:
+	  ((struct sockaddr_in *) dst)->sin_addr.s_addr =
+	       ((struct sockaddr_in *) ss1)->sin_addr.s_addr 
+	       & ((struct sockaddr_in *) ss2)->sin_addr.s_addr;
+	  break;
+
+     case PF_INET6:
+	  for (i = 0; i < 16; i++) 
+	  {
+	       ((struct sockaddr_in6 *)dst)->sin6_addr.s6_addr[i] =
+		    ((struct sockaddr_in6 *)ss1)->sin6_addr.s6_addr[i] &
+		    ((struct sockaddr_in6 *)ss2)->sin6_addr.s6_addr[i];
+	  }
+	  break;
+     default:
+	  return -1;
+     }
+     return 0;
+}
+
+/*
+ * Function: IpNetmaskCreate(int , struct sockaddr_storage *)
+ *
+ * Purpose: Convert netmask length to IPv4/IPv6 or other protocol
+ *            netmask address.
+ *
+ *
+ * Arguments: int netmask_len => netmask length
+ *            struct sockaddr_storage *ss =>  
+ *          
+ *
+ * Returns: 0 for valid netmask, -1 for invalid netmask len, that is,
+ *          less than 0 or more than 32  (ss->family is PF_INET),
+ *          less than 0 or more than 128 (ss->family is PF_INET6),
+ *          ss is NULL, or the ss->family is unknown.
+ *
+ */
+
+int IpNetMaskCreate(int netmask_len, struct sockaddr_storage *ss)
+{
+    int netmask_bytes, netmask_bits, i;
+    u_int8_t mask = 0, maskbit = 0x80L;
+    u_int32_t maskBit = 0x80000000L, Mask = 0;
+
+    if (ss == NULL) {
+	 return -1;
+    }
+    switch(ss->ss_family)
+    {
+    case PF_INET:
+	 if ( netmask_len < 0 || netmask_len > 32)
+	      return -1;
+	 {
+	      struct sockaddr_in *sin;
+	      sin = (struct sockaddr_in *)ss;
+	      memset(&(sin->sin_addr), 0, sizeof(struct in_addr));
+
+	      for (i = netmask_len; i > 0; i--) {
+		   Mask |= maskBit;
+		   maskBit >>= 1;
+	      }
+
+	      sin->sin_addr.s_addr = htonl(Mask);
+	 }
+	 break;
+    case PF_INET6:
+	 if ( netmask_len < 0 || netmask_len > 128)
+	      return -1;
+	 {
+	      struct sockaddr_in6 *sin6;
+	      sin6 = (struct sockaddr_in6 *)ss;
+	      memset(&(sin6->sin6_addr), 0, sizeof(struct in6_addr));
+	      netmask_bytes = netmask_len / 8;
+	      netmask_bits = netmask_len % 8;
+
+	      for (i = 0; i < netmask_bytes ; i++ ) {
+		   sin6->sin6_addr.s6_addr[i] = 0xff;
+	      }
+
+	      for (i = netmask_bits; i > 0; i--) {
+		   mask |= maskbit;
+		   maskbit >>= 1;
+	      }
+
+	      sin6->sin6_addr.s6_addr[netmask_bytes] = mask;
+	 }
+	 break;
+    default:
+	 return -1;
+    }
+    
+    return 0;
+}
+
+/*
+ * Function: IpAddrZero
+ *
+ * Purpose: Convert a supplied IP address to it's network order 32-bit long
+ *          value.  Also convert the CIDR block notation into a real
+ *          netmask.
+ *
+ * Arguments: char *addr  => address string to convert
+ *            IpAddrSet * =>
+ *            
+ *
+ * Returns: 0 for 0.0.0.0 or 0::0, unless 1,
+ *         -1 for unknown pf_family.
+ */
+int
+IpAddrZero(struct sockaddr_storage *ss)
+{
+     int ret = 0, i;
+     struct sockaddr_in *sin;
+     struct sockaddr_in6 *sin6;
+
+     switch(ss->ss_family)
+     {
+     case PF_INET:
+	  sin = (struct sockaddr_in *)ss;
+	  if ( sin->sin_addr.s_addr != 0 )
+	       ret = 1;
+	  break;
+     case PF_INET6:
+	  sin6 = (struct sockaddr_in6 *)ss;
+	  for (i = 0 ; i < 16 ; i ++ )
+	  {
+	       if ( sin6->sin6_addr.s6_addr[i] != 0)
+	       {
+		    ret = 1;
+		    break;
+	       }
+	  }
+	  break;
+     default:
+	  ret = -1;
+     }
+     return ret;
+}
+
+/*
+ * Function: IpAddrEquals
+ *
+ * Purpose: Compare the supplied sockaddr_storage's IP address
+ *          
+ * Arguments: struct sockaddr_stroage *ss1,
+ *            struct sockaddr_stroage *ss2
+ *
+ * Returns: 0 for supplied IP addresses are equal, unless 1,
+ *         -1 for unknown pf_family.
+ */
+int
+IpAddrEquals(struct sockaddr_storage *ss1, struct sockaddr_storage *ss2)
+{
+     int ret = 0, i;
+
+     if (ss1 == NULL || ss2 == NULL)
+	  return -1;
+     if (ss1->ss_family != ss2->ss_family)
+	  return -1;
+
+     switch(ss1->ss_family)
+     {
+     case PF_INET:
+	  if ( ((struct sockaddr_in *)ss1)->sin_addr.s_addr != 
+	       ((struct sockaddr_in *)ss2)->sin_addr.s_addr )
+	       ret = 1;
+	  break;
+     case PF_INET6:
+	  for (i = 0 ; i < 16 ; i ++ )
+	  {
+	       if ( ((struct sockaddr_in6 *)ss1)->sin6_addr.s6_addr[i] !=
+		    ((struct sockaddr_in6 *)ss2)->sin6_addr.s6_addr[i] )
+	       {
+		    ret = 1;
+		    break;
+	       }
+	  }
+	  break;
+     default:
+	  ret = -1;
+     }
+     return ret;
+}
+
+/*
+ * Function: IpAddrGet
+ *
+ * Purpose: Get IPaddress from Packet *p to struct sockaddr_storage
+ *          
+ * Arguments: struct sockaddr_stroage *ss1,
+ *            Packet *p,
+ *            int srcdst => determinate to pick up SRC or DST.
+ *            
+ *
+ * Returns: 0 for success
+ *         -1 for fail.
+ */
+int
+IpAddrGet(struct sockaddr_storage *ss, Packet *p, int srcdst)
+{
+     struct sockaddr_in *sin;
+     struct sockaddr_in6 *sin6;
+
+     if (ss == NULL)
+	  return -1;
+
+     if (p->iph != NULL) 
+     {
+	  sin = (struct sockaddr_in *)ss;
+	  /* sin->sin_len = sizeof(struct sockaddr_in); */
+	  sin->sin_family = PF_INET;
+	  switch (srcdst)
+	  {
+	  case SRC:
+	       sin->sin_port = htons(p->sp);
+	       memmove(&sin->sin_addr, &p->iph->ip_src, sizeof(struct in_addr));
+	       break;
+	  case DST:
+	       sin->sin_port = htons(p->dp);
+	       memmove(&sin->sin_addr, &p->iph->ip_dst, sizeof(struct in_addr));
+	       break;
+	  default:
+	       return -1;
+	  }
+
+     } else if (p->ip6h != NULL) 
+     {
+	  sin6 = (struct sockaddr_in6 *)ss;
+	  /* sin6->sin6_len = sizeof(struct sockaddr_in6); */
+	  sin6->sin6_family = PF_INET6;
+	  switch (srcdst)
+	  {
+	  case SRC:
+	       sin6->sin6_port = htons(p->sp);
+	       memmove(&sin6->sin6_addr, &p->ip6h->ip6_src, sizeof(struct in6_addr));
+	       break;
+	  case DST:
+	       sin6->sin6_port = htons(p->dp);
+	       memmove(&sin6->sin6_addr, &p->ip6h->ip6_dst, sizeof(struct in6_addr));
+	       break;
+	  default:
+	       return -1;
+	  }
+     } else {
+	  return -1;
+     }
+     return 0;
+}
+
+#endif /* HAVE_SOCKADDR_STORAGE */
+
 /* XXX: legacy support function */
 /*
  * Function: ParseIP(char *, IpAddrSet *)
@@ -135,6 +502,134 @@
  *
  * Returns: 0 for normal addresses, 1 for an "any" address
  */
+#ifdef HAVE_GETADDRINFO
+int ParseIP(char *paddr, IpAddrSet *address_data)
+{
+    int i, ret;
+    char **toks;        /* token dbl buffer */
+    int num_toks;       /* number of tokens found by mSplit() */
+    int cidr = 1;       /* is network expressed in CIDR format */
+    int nmask;          /* netmask temporary storage */
+    char *addr;         /* string to parse, eventually a
+                         * variable-contents */
+    struct addrinfo hints, *res;
+    struct sockaddr_storage *ss;
+    int error;
+
+    addr = paddr;
+    memset(&hints, 0, sizeof(hints));
+    hints.ai_family = PF_UNSPEC;
+    hints.ai_socktype = SOCK_DGRAM;
+
+    if(*addr == '!')
+    {
+        address_data->addr_flags |= EXCEPT_IP;
+
+        addr++;  /* inc past the '!' */
+    }
+
+    /* check for wildcards */
+    if(!strcasecmp(addr, "any"))
+    {
+	memset(&(address_data->ip_addr), 0, sizeof(struct sockaddr_storage));
+	memset(&(address_data->netmask), 0, sizeof(struct sockaddr_storage));
+
+	return 1;
+    }
+
+    /* break out the CIDR notation from the IP address */
+    toks = mSplit(addr, "/", 2, &num_toks, 0);
+    /* ":" cannot be used as delimitar becasue IPv6 address notation uses it*/
+
+    /*
+     * if we have a mask spec and it is more than three characters long, assume
+     * it is netmask format
+     */
+
+    if((num_toks > 1) && strlen(toks[1]) > 3)
+    {
+        cidr = 0;
+    }
+
+    if (toks[0] == NULL)
+	 FatalError("ERROR %s(%d) => Unrecognized IP address/netmask %s\n",
+		    file_name, file_line, addr);
+
+    if ((error = getaddrinfo(toks[0], NULL, &hints, &res)) != 0) 
+	 FatalError("ERROR %s(%d): %s", file_name, file_line, gai_strerror(error));
+
+    ss = (struct sockaddr_storage *)res->ai_addr;
+    memmove(&(address_data->ip_addr), ss, res->ai_addrlen);
+
+    switch(num_toks)
+    {
+    case 1:
+	 memset(&(address_data->netmask), 0xff, sizeof(struct sockaddr_storage));
+	 address_data->netmask.ss_family = address_data->ip_addr.ss_family;
+#if HAVE_SOCKADDR_STORAGE_SS_LEN
+	 address_data->netmask.ss_len = address_data->ip_addr.ss_len; 
+#endif
+	 break;
+    case 2:
+	 address_data->netmask.ss_family = address_data->ip_addr.ss_family;
+#if HAVE_SOCKADDR_STORAGE_SS_LEN
+	 address_data->netmask.ss_len = address_data->ip_addr.ss_len;
+#endif
+	 if (cidr)
+	 {
+	      /* convert the CIDR notation into a real live netmask */
+	      nmask = atoi(toks[1]);
+
+	      /* it's pain to differ whether toks[1] is correct if netmask */
+	      /* is /0, so we deploy some sort of evil hack with isdigit */
+
+	      if(!isdigit((int) toks[1][0]))
+		   nmask = -1;
+
+	      if ( (ret = IpNetMaskCreate(nmask, &(address_data->netmask))) != 0 ) 
+	      {
+		   FatalError("ERROR %s(%d): Invalid block for IP address "
+			      "%s\n", file_name, file_line, addr);
+	      }
+	 }
+	 else
+	 {
+	      if (toks[1] == NULL)
+		   FatalError("ERROR %s(%d) => Unrecognized IP address/netmask %s\n",
+			      file_name, file_line, addr);
+
+	      if ((error = getaddrinfo(toks[0], NULL, &hints, &res)) != 0) 
+		   FatalError("ERROR %s(%d): %s", file_name, file_line, gai_strerror(error));
+	      ss = (struct sockaddr_storage *)res->ai_addr;
+	      memmove(&(address_data->ip_addr), ss, res->ai_addrlen);
+
+	 }
+	 break;
+    default:
+	 FatalError("ERROR %s(%d) => Unrecognized IP address/netmask %s\n",
+		    file_name, file_line, addr);
+	 break;
+    }
+
+    /* for valid netmask */
+    ss = (struct sockaddr_storage *)malloc(sizeof(struct sockaddr_storage));
+    if (ss == NULL)
+	 FatalError("ERROR %s(%d) => Cannot allocate enough memory\n",
+		    file_name, file_line);
+
+    memmove(ss, &(address_data->ip_addr), sizeof(struct sockaddr_storage));
+    IpAddrTakeAnd(&(address_data->ip_addr), ss, &(address_data->netmask));
+    free(ss);
+
+    for(i=0;i<num_toks;i++)
+    {
+        free(toks[i]);
+    }
+    freeaddrinfo(res);
+
+    return 0;
+}
+#else
 int ParseIP(char *paddr, IpAddrSet *address_data)
 {
     int i;
@@ -300,5 +795,42 @@
     }
 
     return 0;
-}                                                                                            
+}
+#endif /* HAVE_SOCKADDR_STORAGE */
+
+#if HAVE_SOCKADDR_STORAGE
+int IpAddrComp(struct sockaddr_storage *ss1, struct sockaddr_storage *ss2)
+{
+    struct sockaddr_in *sin1, *sin2;
+    struct sockaddr_in6 *sin6_1, *sin6_2;
+    int i;
+
+    switch(ss1->ss_family)
+    {
+    case PF_INET:
+	sin1 = (struct sockaddr_in *)ss1;
+	sin2 = (struct sockaddr_in *)ss2;
+	if (sin1->sin_addr.s_addr < sin2->sin_addr.s_addr)
+	    return 1;
+	else if (sin1->sin_addr.s_addr < sin2->sin_addr.s_addr)
+	    return -1;
+	else
+	    return 0;
+	break;
+    case PF_INET6:
+	sin6_1 = (struct sockaddr_in6 *)ss1;
+	sin6_2 = (struct sockaddr_in6 *)ss2;
+	for (i = 0 ; i < 16 ; i++ )
+	{
+	     if ( *(uint8_t *)&sin6_1->sin6_addr.s6_addr[i] > *(uint8_t *)&sin6_2->sin6_addr.s6_addr[i] )
+		  return 1;
+	}
+	return 0;
+
+	break;
+    default:
+	return 0;
+    }
+}
+#endif
 
diff -ur snort-2.0.2/src/parser/IpAddrSet.h snort-2.0.2-ipv6/src/parser/IpAddrSet.h
--- snort-2.0.2/src/parser/IpAddrSet.h	Fri Mar 14 17:28:53 2003
+++ snort-2.0.2-ipv6/src/parser/IpAddrSet.h	Sat Nov 29 16:38:11 2003
@@ -1,4 +1,25 @@
-/* $Id: IpAddrSet.h,v 1.2 2003/03/14 08:28:53 chris_reid Exp $ */
+/* $Id: IpAddrSet.h,v 1.4 2003/11/29 07:38:11 abekatsu Exp $ */
+/*
+ * Copyright(C) 2003 Cyber Solutions Inc.
+ *
+ * Author(s):  Katsuhisa ABE <abekatsu@cysols.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
 /*
  * Copyright(C) 2002 Sourcefire, Inc.
  *
@@ -24,11 +45,17 @@
 #define __IP_ADDR_SET_H__
 
 #include <sys/types.h>
+#include <sys/socket.h>
 
 typedef struct _IpAddrSet
 {
+#if HAVE_SOCKADDR_STORAGE
+    struct sockaddr_storage ip_addr;   /* IP addr */
+    struct sockaddr_storage netmask;   /* netmask */
+#else
     u_int32_t ip_addr;   /* IP addr */
     u_int32_t netmask;   /* netmask */
+#endif
     u_int8_t  addr_flags; /* flag for normal/exception processing */
 
     struct _IpAddrSet *next;
@@ -43,6 +70,12 @@
 
 
 /* XXX legacy support function */
+char * GetIpAddr(struct sockaddr_storage *);
 int ParseIP(char *paddr, IpAddrSet *);
 
+int IpAddrTakeAnd(struct sockaddr_storage *, struct sockaddr_storage *, struct sockaddr_storage *);
+int IpAddrZero(struct sockaddr_storage *);
+int IpAddrEquals(struct sockaddr_storage *, struct sockaddr_storage *);
+int IpAddrGet(struct sockaddr_storage *, Packet *, int );
+int IpAddrComp(struct sockaddr_storage *, struct sockaddr_storage *);
 #endif /* __IP_ADDR_SET_H__ */
diff -ur snort-2.0.2/src/parser.c snort-2.0.2-ipv6/src/parser.c
--- snort-2.0.2/src/parser.c	Thu Sep 11 05:25:03 2003
+++ snort-2.0.2-ipv6/src/parser.c	Sat Nov 29 15:58:13 2003
@@ -1,4 +1,4 @@
-/* $Id: parser.c,v 1.4 2003/07/17 05:51:37 tburgess Exp $ */
+/* $Id: parser.c,v 1.7 2003/11/29 06:58:13 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 ** Copyright (C) 2000,2001 Andrew R. Baker <andrewb@uab.edu>
@@ -409,9 +409,11 @@
     while(rule != NULL)
     {
         DumpChain(rule->RuleList->IpList, rule->name, "IP Chains");
+        DumpChain(rule->RuleList->Ip6List, rule->name, "IP6 Chains");
         DumpChain(rule->RuleList->TcpList, rule->name, "TCP Chains");
         DumpChain(rule->RuleList->UdpList, rule->name, "UDP Chains");
         DumpChain(rule->RuleList->IcmpList, rule->name, "ICMP Chains");
+        DumpChain(rule->RuleList->IcmpList, rule->name, "ICMP6 Chains");
         rule = rule->next;
     }
 }
@@ -433,9 +435,11 @@
     while(rule != NULL)
     {
         IntegrityCheck(rule->RuleList->IpList, rule->name, "IP Chains");
+        IntegrityCheck(rule->RuleList->Ip6List, rule->name, "IP6 Chains");
         IntegrityCheck(rule->RuleList->TcpList, rule->name, "TCP Chains");
         IntegrityCheck(rule->RuleList->UdpList, rule->name, "UDP Chains");
         IntegrityCheck(rule->RuleList->IcmpList, rule->name, "ICMP Chains");
+        IntegrityCheck(rule->RuleList->Icmp6List, rule->name, "ICMP6 Chains");
         rule = rule->next;
     }
 
@@ -769,10 +773,18 @@
             rtn_idx = list->IcmpList;
             break;
 
+        case IPPROTO_ICMPV6:
+            rtn_idx = list->Icmp6List;
+            break;
+
         case ETHERNET_TYPE_IP:
             rtn_idx = list->IpList;
             break;
 
+        case ETHERNET_TYPE_IPV6:
+            rtn_idx = list->Ip6List;
+            break;
+
         default:
             rtn_idx = NULL;
             break;
@@ -812,12 +824,24 @@
                 rtn_tmp = list->IcmpList;
                 break;
 
+            case IPPROTO_ICMPV6:
+                list->Icmp6List = (RuleTreeNode *) calloc(sizeof(RuleTreeNode), 
+                        sizeof(char));
+                rtn_tmp = list->Icmp6List;
+                break;
+
             case ETHERNET_TYPE_IP:
                 list->IpList = (RuleTreeNode *) calloc(sizeof(RuleTreeNode), 
                         sizeof(char));
                 rtn_tmp = list->IpList;
                 break;
 
+            case ETHERNET_TYPE_IPV6:
+                list->Ip6List = (RuleTreeNode *) calloc(sizeof(RuleTreeNode), 
+                        sizeof(char));
+                rtn_tmp = list->Ip6List;
+                break;
+
         }
 
         /* copy the prototype header data into the new node */
@@ -1890,9 +1914,15 @@
     if(!strcasecmp(proto_str, "icmp"))
         return IPPROTO_ICMP;
 
+    if(!strcasecmp(proto_str, "icmp6"))
+        return IPPROTO_ICMPV6;
+
     if(!strcasecmp(proto_str, "ip"))
         return ETHERNET_TYPE_IP;
 
+    if(!strcasecmp(proto_str, "ip6"))
+        return ETHERNET_TYPE_IPV6;
+
     if(!strcasecmp(proto_str, "arp"))
         return ETHERNET_TYPE_ARP;
 
@@ -1978,7 +2008,12 @@
                 
             tmp_addr = AllocAddrNode(rtn, mode); 
             ParseIP(tmp, tmp_addr);
+#if HAVE_GETADDRINFO
+            if((IpAddrZero(&(tmp_addr->ip_addr)) == 0) && 
+	       (IpAddrZero(&(tmp_addr->netmask)) == 0))
+#else
             if(tmp_addr->ip_addr == 0 && tmp_addr->netmask == 0)
+#endif
             {
                 switch(mode)
                 {
@@ -2007,7 +2042,12 @@
                     "regular IP address, processing...\n"););
         tmp_addr = AllocAddrNode(rtn, mode);
         ParseIP(tmp, tmp_addr);
+#if HAVE_GETADDRINFO
+	if((IpAddrZero(&tmp_addr->ip_addr) == 0) && 
+	   (IpAddrZero(&tmp_addr->netmask) == 0))
+#else
         if(tmp_addr->ip_addr == 0 && tmp_addr->netmask == 0)
+#endif
         {
             switch(mode)
             {
@@ -2733,9 +2773,15 @@
     rtn_idx = rtn->sip;
     for(rule_idx = rule->sip; rule_idx != NULL; rule_idx = rule_idx->next)
     {
+#ifdef HAVE_GETADDRINFO
+	if(rtn_idx && (IpAddrEquals(&(rtn_idx->ip_addr), &(rule_idx->ip_addr)) == 0) &&
+	   (IpAddrEquals(&(rtn_idx->netmask), &(rule_idx->netmask)) == 0) &&
+	   (rtn_idx->addr_flags == rule_idx->addr_flags))
+#else
         if(rtn_idx && (rtn_idx->ip_addr == rule_idx->ip_addr) &&
                 (rtn_idx->netmask == rule_idx->netmask) &&
                 (rtn_idx->addr_flags == rule_idx->addr_flags))
+#endif
         {
             rtn_idx = rtn_idx->next;
         }
@@ -2748,9 +2794,15 @@
     rtn_idx = rtn->dip;
     for(rule_idx = rule->dip ; rule_idx != NULL; rule_idx = rule_idx->next)
     {
+#ifdef HAVE_GETADDRINFO
+	if(rtn_idx && (IpAddrEquals(&(rtn_idx->ip_addr), &(rule_idx->ip_addr)) == 0) &&
+	   (IpAddrEquals(&(rtn_idx->netmask), &(rule_idx->netmask)) == 0) &&
+	   (rtn_idx->addr_flags == rule_idx->addr_flags))
+#else
         if(rtn_idx && (rtn_idx->ip_addr == rule_idx->ip_addr) &&
                 (rtn_idx->netmask == rule_idx->netmask) &&
                 (rtn_idx->addr_flags == rule_idx->addr_flags))
+#endif
         {
             rtn_idx = rtn_idx->next;
         }
@@ -3121,6 +3173,7 @@
     SetLinks(Activation.TcpList, Dynamic.TcpList);
     SetLinks(Activation.UdpList, Dynamic.UdpList);
     SetLinks(Activation.IcmpList, Dynamic.IcmpList);
+    SetLinks(Activation.Icmp6List, Dynamic.Icmp6List);
 }
 
 
diff -ur snort-2.0.2/src/parser.h snort-2.0.2-ipv6/src/parser.h
--- snort-2.0.2/src/parser.h	Fri Dec 20 04:27:24 2002
+++ snort-2.0.2-ipv6/src/parser.h	Tue Sep 30 13:25:25 2003
@@ -17,7 +17,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */  
 
-/* $Id: parser.h,v 1.15 2002/12/19 19:27:24 andrewbaker Exp $ */
+/* $Id: parser.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 #ifndef __PARSER_H__
 #define __PARSER_H__
 
diff -ur snort-2.0.2/src/pcrm.c snort-2.0.2-ipv6/src/pcrm.c
--- snort-2.0.2/src/pcrm.c	Tue Feb  4 17:27:02 2003
+++ snort-2.0.2-ipv6/src/pcrm.c	Tue Sep 30 13:25:25 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: pcrm.c,v 1.2 2003/02/04 08:27:02 chris_reid Exp $
+**  $Id: pcrm.c,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $
 **
 **  pcrm.c
 **
diff -ur snort-2.0.2/src/pcrm.h snort-2.0.2-ipv6/src/pcrm.h
--- snort-2.0.2/src/pcrm.h	Thu Oct 10 14:05:54 2002
+++ snort-2.0.2-ipv6/src/pcrm.h	Tue Sep 30 13:25:25 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: pcrm.h,v 1.1 2002/10/10 05:05:54 chrisgreen Exp $
+** $Id: pcrm.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $
 **
 ** pcrm.h
 **
diff -ur snort-2.0.2/src/plugbase.c snort-2.0.2-ipv6/src/plugbase.c
--- snort-2.0.2/src/plugbase.c	Tue May 20 14:15:53 2003
+++ snort-2.0.2-ipv6/src/plugbase.c	Sat Nov 29 16:08:53 2003
@@ -1,4 +1,4 @@
-/* $Id: plugbase.c,v 1.76 2003/05/20 05:15:53 chris_reid Exp $ */
+/* $Id: plugbase.c,v 1.3 2003/11/29 07:08:53 abekatsu Exp $ */
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
 **
@@ -89,6 +89,10 @@
 #include "detection-plugins/sp_react.h"
 #include "detection-plugins/sp_respond.h"
 #endif
+#include "detection-plugins/sp_hlim_check.h"
+#include "detection-plugins/sp_icmp6_code_check.h"
+#include "detection-plugins/sp_icmp6_type_check.h"
+#include "detection-plugins/sp_ip6_proto.h"
 #include "output-plugins/spo_alert_sf_socket.h"
 
 /* built-in output plugins */
@@ -149,6 +153,10 @@
     SetupReact();
     SetupRespond();
 #endif
+    SetupIp6Proto();
+    SetupIcmp6CodeCheck();
+    SetupIcmp6TypeCheck();
+    SetupHlimCheck();
 }
 
 /****************************************************************************
@@ -845,7 +853,7 @@
 
 int PacketIsTCP(Packet * p)
 {
-    if(p->iph != NULL && p->tcph != NULL)
+    if((p->iph != NULL || p->ip6h != NULL) && p->tcph != NULL)
         return 1;
 
     return 0;
@@ -855,7 +863,7 @@
 
 int PacketIsUDP(Packet * p)
 {
-    if(p->iph != NULL && p->udph != NULL)
+    if((p->iph != NULL || p->ip6h != NULL) && p->udph != NULL)
         return 1;
 
     return 0;
diff -ur snort-2.0.2/src/plugbase.h snort-2.0.2-ipv6/src/plugbase.h
--- snort-2.0.2/src/plugbase.h	Tue May 20 03:08:03 2003
+++ snort-2.0.2-ipv6/src/plugbase.h	Tue Sep 30 13:25:25 2003
@@ -16,7 +16,7 @@
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
-/* $Id: plugbase.h,v 1.58 2003/05/19 18:08:03 chrisgreen Exp $ */
+/* $Id: plugbase.h,v 1.1.1.1 2003/09/30 04:25:25 abekatsu Exp $ */
 #ifndef __PLUGBASE_H__
 #define __PLUGBASE_H__
 
diff -ur snort-2.0.2/src/plugin_enum.h snort-2.0.2-ipv6/src/plugin_enum.h
--- snort-2.0.2/src/plugin_enum.h	Sat Nov  2 05:12:06 2002
+++ snort-2.0.2-ipv6/src/plugin_enum.h	Thu Dec  4 15:26:31 2003
@@ -5,7 +5,7 @@
   No more grepping to make your own plugin!
 */
 
-/* $Id: plugin_enum.h,v 1.3 2002/11/01 20:12:06 roesch Exp $ */
+/* $Id: plugin_enum.h,v 1.5 2003/12/04 06:26:31 abekatsu Exp $ */
 
 enum {
     PLUGIN_CLIENTSERVER,
@@ -33,4 +33,10 @@
     PLUGIN_TCP_WIN_CHECK,
     PLUGIN_TTL_CHECK,
     PLUGIN_BYTE_TEST,
+    PLUGIN_HLIM_CHECK,
+    PLUGIN_ICMP6_CODE,
+    PLUGIN_ICMP6_TYPE,
+    PLUGIN_ICMP6_SEQ_CHECK,
+    PLUGIN_ICMP6_ID_CHECK,
+    PLUGIN_IP6_PROTO_CHECK,
 };
diff -ur snort-2.0.2/src/preprocessors/http-resp.c snort-2.0.2-ipv6/src/preprocessors/http-resp.c
--- snort-2.0.2/src/preprocessors/http-resp.c	Wed Jul 23 03:24:51 2003
+++ snort-2.0.2-ipv6/src/preprocessors/http-resp.c	Tue Sep 30 13:25:26 2003
@@ -1,6 +1,6 @@
 /*
 **
-*  $Id: http-resp.c,v 1.3 2003/07/22 18:24:51 chrisgreen Exp $
+*  $Id: http-resp.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 ** http-resp.c
 **
diff -ur snort-2.0.2/src/preprocessors/http-resp.h snort-2.0.2-ipv6/src/preprocessors/http-resp.h
--- snort-2.0.2/src/preprocessors/http-resp.h	Thu Oct 10 14:05:58 2002
+++ snort-2.0.2-ipv6/src/preprocessors/http-resp.h	Tue Sep 30 13:25:26 2003
@@ -1,6 +1,6 @@
 /*
 **
-*  $Id: http-resp.h,v 1.1 2002/10/10 05:05:58 chrisgreen Exp $
+*  $Id: http-resp.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 ** http-perf.h
 **
diff -ur snort-2.0.2/src/preprocessors/perf-base.c snort-2.0.2-ipv6/src/preprocessors/perf-base.c
--- snort-2.0.2/src/preprocessors/perf-base.c	Tue Feb  4 17:27:04 2003
+++ snort-2.0.2-ipv6/src/preprocessors/perf-base.c	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: perf-base.c,v 1.4 2003/02/04 08:27:04 chris_reid Exp $
+** $Id: perf-base.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 ** perf-base.c
 **
diff -ur snort-2.0.2/src/preprocessors/perf-base.h snort-2.0.2-ipv6/src/preprocessors/perf-base.h
--- snort-2.0.2/src/preprocessors/perf-base.h	Thu Oct 10 14:05:58 2002
+++ snort-2.0.2-ipv6/src/preprocessors/perf-base.h	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-** $Id: perf-base.h,v 1.1 2002/10/10 05:05:58 chrisgreen Exp $
+** $Id: perf-base.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 ** perf-base.h
 **
diff -ur snort-2.0.2/src/preprocessors/perf-event.c snort-2.0.2-ipv6/src/preprocessors/perf-event.c
--- snort-2.0.2/src/preprocessors/perf-event.c	Thu Oct 10 14:05:58 2002
+++ snort-2.0.2-ipv6/src/preprocessors/perf-event.c	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: perf-event.c,v 1.1 2002/10/10 05:05:58 chrisgreen Exp $
+**  $Id: perf-event.c,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 **  perf-event.c
 **
diff -ur snort-2.0.2/src/preprocessors/perf-event.h snort-2.0.2-ipv6/src/preprocessors/perf-event.h
--- snort-2.0.2/src/preprocessors/perf-event.h	Thu Oct 10 14:05:58 2002
+++ snort-2.0.2-ipv6/src/preprocessors/perf-event.h	Tue Sep 30 13:25:26 2003
@@ -1,5 +1,5 @@
 /*
-**  $Id: perf-event.h,v 1.1 2002/10/10 05:05:58 chrisgreen Exp $
+**  $Id: perf-event.h,v 1.1.1.1 2003/09/30 04:25:26 abekatsu Exp $
 **
 **  perf-event.h
 **
